<?php
/*
  $Id: cm_header_holiday.php
  $Loc: catalog/includes/modules/content/header/

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Holiday-Promotional Message 3.0.0. BS by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2019 Rainer Schmied

  All rights reserved.﻿﻿

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  class cm_header_holiday {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_HEADER_HOLIDAY_TITLE;
      $this->description = MODULE_CONTENT_HEADER_HOLIDAY_DESCRIPTION;
      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';
      $this->description .= '<div class="secWarning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';

      if ( defined('MODULE_CONTENT_HEADER_HOLIDAY_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_HEADER_HOLIDAY_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_HEADER_HOLIDAY_STATUS == 'True');
      }
    }

    
    function execute() {
      global $PHP_SELF, $oscTemplate, $language;

      if (tep_not_null(MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_PAGES)) {
        $pages_array = array();

        foreach (explode(';', MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_PAGES) as $page) {
          $page = trim($page);

          if (!empty($page)) {
            $pages_array[] = $page;
          }
        }

        if (in_array(basename($PHP_SELF), $pages_array)) {
      
      $content_width = (int)MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_WIDTH;
      
      ob_start();
      include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
      $template = ob_get_clean();

      $oscTemplate->addContent($template, $this->group);
        }
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_HEADER_HOLIDAY_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Header Holiday Message Module', 'MODULE_CONTENT_HEADER_HOLIDAY_STATUS', 'True', 'Do you want to enable the Holiday Message content module?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_WIDTH', '12', 'What width container should the content be shown in?', '6', '2', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Align', 'MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_ALIGN', 'text-center', 'How should the content be aligned?', '6', '3', 'tep_cfg_select_option(array(\'text-left\', \'text-center\', \'text-right\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Pages', 'MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_PAGES', '" . implode(';', $this->get_default_pages()) . "', 'The pages to add the Holiday Message to.', '6', '4', 'cm_header_holidays_show_pages', 'cm_header_holidays_edit_pages(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_HEADER_HOLIDAY_SORT_ORDER', '1000', 'Sort order of display. Lowest is displayed first.', '6', '5', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Include Header Holiday Message in Order E-Mail', 'MODULE_CONTENT_HEADER_HOLIDAY_ORDER_MAIL', 'True', 'Do you want to add the Holiday Message to the order confirmation e-mail?', '6', '6', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      include('includes/classes/language.php');
      $lng = new language;
      foreach($lng->catalog_languages as $key => $value) {
      	$key = strtoupper($value['directory']);
        tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Holiday Title " . $key . "', 'MODULE_CONTENT_HEADER_HOLIDAY_HEADER_" . $key . "', 'Holiday Title', 'Holiday Message Title for " . $key . " language.', '6', '7', 'tep_cfg_module_textarea(', now())");
        tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Your Holiday Text " . $key . "', 'MODULE_CONTENT_HEADER_HOLIDAY_TEXT_" . $key . "', 'Place any message you want to here, you can use it for any type of notice not just holidays', 'Holiday Message Title for " . $key . " language.', '6', '8', 'tep_cfg_module_textarea(', now())");
      }
    }
    
    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      include('includes/classes/language.php');
      $lng = new language;
      $KeysArray = array('MODULE_CONTENT_HEADER_HOLIDAY_STATUS', 'MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_PAGES', 'MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_WIDTH', 'MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_ALIGN', 'MODULE_CONTENT_HEADER_HOLIDAY_SORT_ORDER', 'MODULE_CONTENT_HEADER_HOLIDAY_ORDER_MAIL');
      foreach($lng->catalog_languages as $key => $value) {
      	$key = strtoupper($value['directory']);
      	array_push($KeysArray, 'MODULE_CONTENT_HEADER_HOLIDAY_HEADER_' . $key);
      	array_push($KeysArray, 'MODULE_CONTENT_HEADER_HOLIDAY_TEXT_' . $key);
      }
      return $KeysArray;
    }
    
    function get_default_pages() {
      return array('checkout_confirmation.php',
                   'checkout_payment.php',
                   'checkout_shipping.php',
                   'contact_us.php',
                   'shopping_cart.php');
    }
  }

  function cm_header_holidays_show_pages($text) {
  	return nl2br(implode("\n", explode(';', $text)));
  }

  function cm_header_holidays_edit_pages($values, $key) {
    global $PHP_SELF;

    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG)) {
	    while ($file = $dir->read()) {
	      if (!is_dir(DIR_FS_CATALOG . $file)) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }

    $values_array = explode(';', $values);

    $output = '';
    foreach ($files_array as $file) {
      $output .= tep_draw_checkbox_field('cm_holiday_file[]', $file, in_array($file, $values_array)) . '&nbsp;' . tep_output_string($file) . '<br />';
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_files"');

    $output .= '<script>
                function htrn_update_cfg_value() {
                  var htrn_selected_files = \'\';

                  if ($(\'input[name="cm_holiday_file[]"]\').length > 0) {
                    $(\'input[name="cm_holiday_file[]"]:checked\').each(function() {
                      htrn_selected_files += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_selected_files.length > 0) {
                      htrn_selected_files = htrn_selected_files.substring(0, htrn_selected_files.length - 1);
                    }
                  }

                  $(\'#htrn_files\').val(htrn_selected_files);
                }

                $(function() {
                  htrn_update_cfg_value();

                  if ($(\'input[name="cm_holiday_file[]"]\').length > 0) {
                    $(\'input[name="cm_holiday_file[]"]\').change(function() {
                      htrn_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }

  if(!function_exists('tep_cfg_module_textarea')) {
    function tep_cfg_module_textarea($text, $key = '') {
      $name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');
      return tep_draw_textarea_field($name, false, 35, 5, $text, 'style="font: inherit;"');
    }
  }
