<?php
/*
  $Id: cm_header_holiday.php
  $Loc: catalog/includes/modules/content/header/

  Holiday-Promotional Message 3.1.2 Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Based on an idea by fimble

  Copyright (c) 2020 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  class cm_header_holiday extends abstract_executable_module {

    const CONFIG_KEY_BASE = 'MODULE_CONTENT_HEADER_HOLIDAY_';

    public function __construct() {
      parent::__construct(__FILE__);
      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';
    }


    function execute() {
      global $language;

      $pages_array = page_selection::_get_pages(MODULE_CONTENT_HEADER_HOLIDAY_PAGES);

      if (in_array(basename($GLOBALS['PHP_SELF']), $pages_array)) {

        $content_width = (int)MODULE_CONTENT_HEADER_HOLIDAY_CONTENT_WIDTH;

        $tpl_data = [ 'group' => $this->group, 'file' => __FILE__ ];
        include 'includes/modules/content/cm_template.php';
      }
    }

    protected function get_parameters() {
      $config_parameters = [
        $this->config_key_base . 'STATUS' => [
          'title' => 'Enable Header Holiday Message Module',
          'value' => 'True',
          'desc' => 'Do you want to enable the Holiday Message content module?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        $this->config_key_base . 'CONTENT_WIDTH' => [
          'title' => 'Content Width',
          'value' => '12',
          'desc' => 'What width container should the content be shown in?',
          'set_func' => "tep_cfg_select_option(['12', '11', '10', '9', '8', '7', '6', '5', '4', '3', '2', '1'], ",
        ],
        $this->config_key_base . 'CONTENT_ALIGN' => [
          'title' => 'Content Align',
          'value' => 'text-center',
          'desc' => 'How should the content be aligned?',
          'set_func' => "tep_cfg_select_option(['text-left', 'text-center', 'text-right'], ",
        ],
        $this->config_key_base . 'PAGES' => [
          'title' => 'Pages',
          'value' => 'index.php;product_info.php;shopping_cart.php',
          'desc' => 'The pages to add the Holiday Message to.',
          'set_func' => "page_selection::_edit_pages(",
          'use_func' => 'page_selection::_show_pages',
        ],
        $this->config_key_base . 'ORDER_MAIL' => [
          'title' => 'Include Holiday Message in Order E-Mail',
          'value' => 'True',
          'desc' => 'Do you want to add the Holiday Message to the order confirmation e-mail?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        $this->config_key_base . 'SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '0',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];

      $lng = new language;
      foreach($lng->catalog_languages as $id => $value) {
      	$key = strtoupper($value['directory']);
        $config_parameters[$this->config_key_base . 'HEADER_' . $key] = [
            'title' => 'Holiday Title ' . $key,
            'value' => 'Holiday Title',
            'desc' => 'Holiday Message Title for ' . $key . ' language.',
            'set_func' => "cm_header_holiday::tep_cfg_module_textarea(",
        ];
        $config_parameters[$this->config_key_base . 'TEXT_' . $key] = [
            'title' => 'Your Holiday Text ' . $key,
            'value' => 'Place any message you want to here, you can use it for any type of notice not just holidays',
            'desc' => 'Holiday Message Text for ' . $key . ' language.',
            'set_func' => "cm_header_holiday::tep_cfg_module_textarea(",
        ];
      }

      return $config_parameters;
    }

    public static function tep_cfg_module_textarea($text, $key = '') {
      $name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');
      return tep_draw_textarea_field($name, false, 35, 5, $text, 'style="font: inherit;"');
    }

  }
